树的直径与重心

树的直径

定义
树的直径:树中距离最远的两点间的距离。


两种做法
1.取任意一个点为起点做一次dfs,找到距离其最远的点 s ,再从点 s 开始做一次dfs,找到距离点 s 最远的点 t ,点 s,t 即为该树一条直径的两个端点。
2.树形DP, f[i][0],f[i][1] 分别记录以顶端端点为i的最长链和次长链长度,不断更新即可, ans=max(f[i][0]+f[i][1])


模板题
POJ1985

type
  node=record
  re,cap,next:longint;
end;
var
d:string;
x,y,z,ans,i,n,m,cnt:longint;
f:array[0..50000] of longint;
vs:array[0..500000] of boolean;
dp:array[0..50000,0..2] of longint;
e:array[0..500000] of node;
procedure dfs(x:longint);
var
max1,max2,tmp:longint;
begin
  vs[x]:=true;
  max1:=0;max2:=0;
  tmp:=f[x];
  while tmp<>0 do
  begin
    if vs[e[tmp].re] then
    begin
      tmp:=e[tmp].next;continue;
    end;
    dfs(e[tmp].re);
    if dp[e[tmp].re,0]+e[tmp].cap>max1 then 
    begin
      max2:=max1;
      max1:=dp[e[tmp].re,0]+e[tmp].cap;
    end
    else
    if dp[e[tmp].re,0]+e[tmp].cap>max2 then max2:=dp[e[tmp].re,0]+e[tmp].cap;
    tmp:=e[tmp].next;
  end;
  dp[x,0]:=max1;dp[x,1]:=max2;
end;

begin
  readln(n,m);
  for i:=1 to m do
  begin
    read(x,y,z);
    readln(d);
    inc(cnt);with e[cnt] do begin cap:=z;re:=y;next:=f[x];end;f[x]:=cnt;
    inc(cnt);with e[cnt] do begin cap:=z;re:=x;next:=f[y];end;f[y]:=cnt;
  end;
  dfs(1);
  for i:=1 to n do
  if dp[i,0]+dp[i,1]>ans then ans:=dp[i,0]+dp[i,1];
  writeln(ans);
end.

一些性质与应用
显然直径两端点都为叶子节点,而对于树中的任意节点,距离其最远的节点一定可以为某个直径端点,也就是说以该点为端点的最长链,一定会与直径有重合部分。

Codeforces 337D
题意简述:在树中,有若干控制点,每个控制点都有相同的控制范围(距离 <=d ),求能被所有控制点控制的点的个数。
分析:在树中找到一条长度最长的链满足其两个端点均为控制点,我们不妨也称之为“直径”。那对于树中任意节点,该节点到距离其最远的控制点一定可以为某个“直径”端点。找出“直径”后,从两个端点dfs求距离即可。

type
  edge=record
  re,next:longint;
end;
var
i,n,m,dd,mx,k,p,ans,x,y,cnt:longint;
e:array[0..200020] of edge;
d,b,f,a:array[0..100010] of longint;
flag,boo:array[0..100010] of boolean;

function max(x,y:longint):longint;begin if x>y then exit(x);exit(y);end;

procedure add(x,y:longint);begin inc(cnt);with e[cnt] do begin re:=y;next:=f[x];end;f[x]:=cnt;end;

procedure dfs(x,pa:longint);
var tmp:longint;
begin
  tmp:=f[x];
  while tmp<>0 do
  begin
    with e[tmp] do
    if re<>pa then
    begin
      d[re]:=d[x]+1;
      dfs(re,x);
    end;
    tmp:=e[tmp].next;
  end;
end;

procedure work(x,pa:longint);
var tmp:longint;
begin
  if (b[x]<=dd)and(d[x]<=dd) then inc(ans);
  tmp:=f[x];
  while tmp<>0 do
  begin
    with e[tmp] do
    if re<>pa then
    begin
      b[re]:=b[x]+1;
      work(re,x);
    end;
    tmp:=e[tmp].next;
  end;
end;

begin
  readln(n,m,dd);
  for i:=1 to m do
  begin read(a[i]);boo[a[i]]:=true;end;
  for i:=1 to n-1 do
  begin
    read(x,y);
    add(x,y);add(y,x);
  end;
  dfs(1,0);
  for i:=1 to m do
  if d[a[i]]>mx then 
  begin mx:=d[a[i]];k:=a[i];end;
  fillchar(d,n*4+4,0);
  dfs(k,0);
  mx:=-1;
  for i:=1 to m do
  if d[a[i]]>mx then
  begin mx:=d[a[i]];p:=a[i];end;
  work(p,0);
  writeln(ans);
end.

树的重心

定义
树的重心:以这个点为根,那么所有的子树(不算整个树自身)的大小都不超过整个树大小的一半。


性质
1.树中所有点到某个点的距离和中,到重心的距离和是最小的,重心可能会有多个。
脑洞类比:距离和最小(边带权)是以重心为根的树,带权距离和(点带权,边权为1)最小是哈夫曼树。
2.把两个树通过一条边相连得到一个新的树,那么新的树的重心在连接原来两个树的重心的路径上。
3.把一个树添加或删除一个叶子,那么它的重心最多只移动一条边的距离。


模板题
POJ1655
根据定义进行树形DP,一遍dfs的做法。

const
maxn=20020;
type
  edge=record
  re,next:longint;
end;
var
i,n,k,ans,tt,cases,x,y,tot:longint;
vs:array[0..maxn] of boolean;
cnt,f:array[0..maxn] of longint;
e:array[0..maxn*2] of edge;

procedure add(x,y:longint);begin inc(tot);with e[tot] do begin re:=y;next:=f[x];end;f[x]:=tot;end;

procedure dfs(x:longint);
var tmp,mx:longint;
begin
  vs[x]:=true;
  tmp:=f[x];mx:=0;cnt[x]:=1;
  while tmp<>0 do
  begin
    with e[tmp] do
    if not vs[re] then
    begin
      dfs(re);
      inc(cnt[x],cnt[re]);
      if cnt[re]>mx then mx:=cnt[re];
    end;
    tmp:=e[tmp].next;
  end;
  if n-cnt[x]>mx then mx:=n-cnt[x];
  if (mxor(mx=ans)and(xthen
  begin
    ans:=mx;k:=x;
  end;
end;


begin
  readln(cases);
  for tt:=1 to cases do
  begin
    readln(n);tot:=0;
    fillchar(f,sizeof(f),0);
    fillchar(vs,sizeof(vs),0);
    for i:=1 to n-1 do begin read(x,y);add(x,y);add(y,x);end;
    ans:=maxlongint;
    dfs(1);
    writeln(k,' ',ans);
  end;
end.

性质一例题
感觉性质1还是挺有用的(可以出一些看上去很水的题)。
Tyvj 3948
预告:非满分解法
题意简述:在一棵树中,每个点上有一个人,求找到两个集合点,使所有人都到达集合点的距离和最短(到任意一个集合点均可)。
分析:枚举断开每条树边,对两侧分别求重心计算即可,显然一定可以枚举到最优方案啊。


其他
求树的重心很多时候还是用来辅助树分治的。

你可能感兴趣的:(学习笔记)